{{
  Written by Duane Degn
}}      
CON
  _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000

 
  MAX_SPEED = 200             
 
  ACCELERATION = 2 
  
  DISTANCE_TO_MOVE = 40_000

  MAX_DISPLAY_Y = 220
  DISPLAY_SCALE = DISTANCE_TO_MOVE / MAX_DISPLAY_Y
  
  ' driverState enumeration
  #0, RAMP_UP, FULL_SPEED, RAMP_DOWN, STOP

VAR

  long speed, time, distance
  long rampDownTarget
  
  byte driverState
  
OBJ
  term :  "pc_interface"
      
PUB Main
  term.start(31,30)
  driverState := RAMP_UP
  speed := 0
  repeat
    term.str(string(13, "Press any key to start."))
    result := term.key
  while result == 0
  term.cls  
  repeat 
    Move
    term.plot(time++, MAX_DISPLAY_Y - (distance / DISPLAY_SCALE))
  while driverState <> STOP
  repeat

PUB Move

  case driverState
    RAMP_UP:
      RampUp 
    FULL_SPEED:
      FullSpeed
    RAMP_DOWN:
      RampDown
  distance += speed
        
PUB RampUp

  result := speed + ACCELERATION
  if result => MAX_SPEED
    speed := MAX_SPEED         
    rampDownTarget := DISTANCE_TO_MOVE - distance
    if rampDownTarget =< 0
      driverState := RAMP_DOWN
    else
      driverState := FULL_SPEED
  else
    speed := result
          
PUB FullSpeed

  if distance + speed => rampDownTarget
    driverState := RAMP_DOWN

PUB RampDown

  result := speed - ACCELERATION
  result #>= 1
  if distance + result => DISTANCE_TO_MOVE
    speed := DISTANCE_TO_MOVE - distance
    driverState := STOP
  else
    speed := result
    